Index: /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90
===================================================================
--- /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 7712)
+++ /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 7713)
@@ -1456,4 +2027,115 @@
          ENDIF
          
+      ENDIF
+
+      !  - log10(chlorophyll)
+      IF ( ln_logchl ) THEN
+
+         ! Copy data from logchldatqc to logchldata structures
+         DO jlogchlset = 1, nlogchlsets
+
+            CALL obs_surf_decompress( logchldatqc(jlogchlset), &
+                 &                    logchldata(jlogchlset), .TRUE., numout )
+
+         END DO
+         
+         ! Mark as bad observations with no valid model counterpart due to activities in dia_obs
+         ! Seem to need to set to fill value rather than marking as bad to be effective, so do both
+         DO jlogchlset = 1, nlogchlsets
+            WHERE ( logchldata(jlogchlset)%rmod(:,1) == obfillflt )
+               logchldata(jlogchlset)%nqc(:)    = 1
+               logchldata(jlogchlset)%robs(:,1) = obfillflt
+            END WHERE
+         END DO
+
+         ! Write the logchl data
+         DO jlogchlset = 1, nlogchlsets
+      
+            WRITE(cdtmp,'(A,I2.2)')'logchlfb_',jlogchlset
+            CALL obs_wri_logchl( cdtmp, logchldata(jlogchlset) )
+
+         END DO
+
+      ENDIF
+
+      !  - spm
+      IF ( ln_spm ) THEN
+
+         ! Copy data from spmdatqc to spmdata structures
+         DO jspmset = 1, nspmsets
+
+            CALL obs_surf_decompress( spmdatqc(jspmset), &
+                 &                    spmdata(jspmset), .TRUE., numout )
+
+         END DO
+
+         ! Write the spm data
+         DO jspmset = 1, nspmsets
+      
+            WRITE(cdtmp,'(A,I2.2)')'spmfb_',jspmset
+            CALL obs_wri_spm( cdtmp, spmdata(jspmset) )
+
+         END DO
+
+      ENDIF
+
+      !  - fco2
+      IF ( ln_fco2 ) THEN
+
+         ! Copy data from fco2datqc to fco2data structures
+         DO jfco2set = 1, nfco2sets
+
+            CALL obs_surf_decompress( fco2datqc(jfco2set), &
+                 &                    fco2data(jfco2set), .TRUE., numout )
+
+         END DO
+         
+         ! Mark as bad observations with no valid model counterpart due to fCO2 not being in the restart
+         ! Seem to need to set to fill value rather than marking as bad to be effective, so do both
+         DO jfco2set = 1, nfco2sets
+            WHERE ( fco2data(jfco2set)%rmod(:,1) == obfillflt )
+               fco2data(jfco2set)%nqc(:)    = 1
+               fco2data(jfco2set)%robs(:,1) = obfillflt
+            END WHERE
+         END DO
+
+         ! Write the fco2 data
+         DO jfco2set = 1, nfco2sets
+      
+            WRITE(cdtmp,'(A,I2.2)')'fco2fb_',jfco2set
+            CALL obs_wri_fco2( cdtmp, fco2data(jfco2set) )
+
+         END DO
+
+      ENDIF
+
+      !  - pco2
+      IF ( ln_pco2 ) THEN
+
+         ! Copy data from pco2datqc to pco2data structures
+         DO jpco2set = 1, npco2sets
+
+            CALL obs_surf_decompress( pco2datqc(jpco2set), &
+                 &                    pco2data(jpco2set), .TRUE., numout )
+
+         END DO
+         
+         ! Mark as bad observations with no valid model counterpart due to pco2 not being in the restart
+         ! Seem to need to set to fill value rather than marking as bad to be effective, so do both
+         DO jpco2set = 1, npco2sets
+            WHERE ( pco2data(jpco2set)%rmod(:,1) == obfillflt )
+               pco2data(jpco2set)%nqc(:)    = 1
+               pco2data(jpco2set)%robs(:,1) = obfillflt
+            END WHERE
+         END DO
+
+         ! Write the pco2 data
+         DO jpco2set = 1, npco2sets
+      
+            WRITE(cdtmp,'(A,I2.2)')'pco2fb_',jpco2set
+            CALL obs_wri_pco2( cdtmp, pco2data(jpco2set) )
+
+         END DO
+
       ENDIF
 
Index: /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_fco2.F90
===================================================================
--- /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_fco2.F90	(revision 7713)
+++ /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_fco2.F90	(revision 7713)
@@ -0,0 +1,35 @@
+MODULE obs_fco2
+   !!=====================================================================
+   !!                       ***  MODULE  obs_fco2  ***
+   !! Observation diagnostics: Storage space for fco2 observations
+   !!                          arrays and additional flags etc.
+   !!=====================================================================
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+   
+   !! * Modules used 
+   USE obs_surf_def ! Definition of surface data types and tools
+
+   IMPLICIT NONE
+   
+   SAVE
+
+   !! * Routine accessibility
+   PRIVATE
+
+   PUBLIC nfco2vars, nfco2extr, nfco2sets, fco2data, fco2datqc
+
+   !! * Shared Module variables
+   INTEGER :: nfco2vars                               ! Number of fco2data variables
+   INTEGER :: nfco2extr                               ! Number of fco2data extra 
+                                                      ! variables
+   INTEGER :: nfco2sets                               ! Number of fco2data sets
+   TYPE(obs_surf), POINTER, DIMENSION(:) :: fco2data  ! Initial fco2 data
+   TYPE(obs_surf), POINTER, DIMENSION(:) :: fco2datqc ! Sea ice data after quality control
+
+END MODULE obs_fco2
+
Index: /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_fco2_io.F90
===================================================================
--- /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_fco2_io.F90	(revision 7713)
+++ /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_fco2_io.F90	(revision 7713)
@@ -0,0 +1,30 @@
+MODULE obs_fco2_io
+   !!======================================================================
+   !!                       ***  MODULE obs_fco2_io  ***
+   !! Observation operators : I/O for fco2 files
+   !!======================================================================
+   !! History : 
+   !!             !  09-01  (K. Mogensen) Initial version
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !!   read_fco2file    :  Read a obfbdata structure from a fco2 file
+   !!----------------------------------------------------------------------
+   USE par_kind
+   USE obs_utils
+   USE obs_fbm
+   USE julian
+   USE netcdf
+
+   IMPLICIT NONE
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+#include "obsfco2_io.h90"
+
+END MODULE obs_fco2_io
Index: /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_logchl.F90
===================================================================
--- /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_logchl.F90	(revision 7713)
+++ /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_logchl.F90	(revision 7713)
@@ -0,0 +1,35 @@
+MODULE obs_logchl
+   !!=====================================================================
+   !!                       ***  MODULE  obs_logchl  ***
+   !! Observation diagnostics: Storage space for logchl observations
+   !!                          arrays and additional flags etc.
+   !!=====================================================================
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+   
+   !! * Modules used 
+   USE obs_surf_def ! Definition of surface data types and tools
+
+   IMPLICIT NONE
+   
+   SAVE
+
+   !! * Routine accessibility
+   PRIVATE
+
+   PUBLIC nlogchlvars, nlogchlextr, nlogchlsets, logchldata, logchldatqc
+
+   !! * Shared Module variables
+   INTEGER :: nlogchlvars                               ! Number of logchldata variables
+   INTEGER :: nlogchlextr                               ! Number of logchldata extra 
+                                                        ! variables
+   INTEGER :: nlogchlsets                               ! Number of logchldata sets
+   TYPE(obs_surf), POINTER, DIMENSION(:) :: logchldata  ! Initial logchl data
+   TYPE(obs_surf), POINTER, DIMENSION(:) :: logchldatqc ! Sea ice data after quality control
+
+END MODULE obs_logchl
+
Index: /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_logchl_io.F90
===================================================================
--- /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_logchl_io.F90	(revision 7713)
+++ /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_logchl_io.F90	(revision 7713)
@@ -0,0 +1,30 @@
+MODULE obs_logchl_io
+   !!======================================================================
+   !!                       ***  MODULE obs_logchl_io  ***
+   !! Observation operators : I/O for logchl files
+   !!======================================================================
+   !! History : 
+   !!             !  09-01  (K. Mogensen) Initial version
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !!   read_logchlfile    :  Read a obfbdata structure from a logchl file
+   !!----------------------------------------------------------------------
+   USE par_kind
+   USE obs_utils
+   USE obs_fbm
+   USE julian
+   USE netcdf
+
+   IMPLICIT NONE
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+#include "obslogchl_io.h90"
+
+END MODULE obs_logchl_io
